
{% extends 'base.html' %}
{% block content %}
    {% if active %}
        <h4 id="question_count"></h4>

    <div class="d-flex flex-column justify-content-center start-main"> <h1 id="question_text"></h1>
<form action="" id="question">
    <div id="question_ans"></div>

</form>
        <div class="text-center" id="finish_test"> <h1 >Test is finished</h1> <a href="/" class="btn btn-primary">Home</a></div>
        <div class="text-center" id="winner_list"></div>
    </div>


</div>
    {% else %}
        <h1>Group is not active more</h1>
        <a href="/" class="btn btn-primary">Home</a>
    {% endif %}
<script>
        var group_id = {{ group_id_json }};
        var question_set = JSON.parse({{ question_set }});
        {#console.log(question_set)#}
        $("#finish_test").hide()
        var last_question_no = -1;
        var chatSocket = new WebSocket(
            'ws://' + window.location.host +
            '/ws/chat/' + group_id + '/');

        function shuffle(array) {
          var currentIndex = array.length, temporaryValue, randomIndex;

          // While there remain elements to shuffle...
          while (0 !== currentIndex) {

            // Pick a remaining element...
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;

            // And swap it with the current element.
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
          }

          return array;
        }


        function render_question_ans(question_no) {
            {#console.log(question_no !== last_question_no)#}
            if ( question_no !== last_question_no){
                var question_form = $('#question').empty();
                var question_ans_div = $('#question_ans').empty();
                var fields = question_set[question_no]['fields'];
                var ans_array =  shuffle([fields['false_answer1'],fields['false_answer2'],
                                    fields['false_answer3'],fields['true_answer']]);
                var question = '<h1>'+fields['question']+'</h1>';
                question_form.append(question);
                for (var i=0; i<4;i++){
                    var answer_input = '<input type="radio" name="answer" value="'+ans_array[i]+'" id="'+i+'" onclick="check_answer()">';
                    var answer_label = '<label class="answer-div col-md-5 btn btn-secondary m-1" for="'+i+'">'+ans_array[i]+'</label>';


                    question_form.append(answer_input,answer_label)
                }
                last_question_no = question_no;

            }
        }
        function render_question_text(question_no){
            var fields = question_set[question_no]['fields'];
            var question_text_div = $('#question_text').empty();
            question_text_div.show();
            var question_form = $('#question').empty();
            var text = fields['question'];
            question_text_div.append(text);
            setTimeout(function () {
                question_text_div.hide()
            },1000);
        }
        function check_answer(){
            var answer = $("#question").find("input[type='radio']:checked").val();
            {#console.log(last_question_no)#}
            if (answer === question_set[last_question_no]['fields']['true_answer']){
                ws_send(chatSocket,'next_question',{'all_question_no':question_set.length})
            }
            else console.log('false ans')
        }
        setTimeout(function (args) {  ws_send(chatSocket,'question_no','')},1000);
        function ws_send(socket,event,message){
            socket.send(JSON.stringify({
            'event': event,
            'message': message,
        }));}
        chatSocket.onmessage = function (e) {
            {#console.log(e.data)#}
            data = JSON.parse(e.data)['message']
            event = data['event'];
            message = data['message'];
            if (event==='question_no'){
                var question_no = message['question_no']
                render_question_text(question_no)
                {#ws_send(chatSocket,'set_timer',{'timer':question_set[question_no]['fields']['timer']})#}
                setTimeout(function () {
                    ws_send(chatSocket,'get_right_answers_count',{'all_question_no':question_set.length})
                    render_question_ans(question_no)
                },1000)

            }

            if (event === 'next_question'){
                {#console.log('next_question');#}
                ws_send(chatSocket,'question_no','')
            }
            if (event === 'get_right_answers_count'){
                var question_count_div = $('#question_count').empty();
                var right_ans_count = 'Right answers count:'+message['right_answers_count']+'</br>';
                var false_ans_count = 'False answers count:'+message['false_answers_count']+'</br>';
                question_count_div.append(right_ans_count,false_ans_count);
            }
            if (event === 'finish_test'){
                $('#finish_test').show()
                ws_send(chatSocket,'get_right_answers_count',{'all_question_no':question_set.length})
                var question_form = $('#question').empty();
            }

            if (event==='get_winners_list'){
                var winners_list_div = $('#winner_list').empty();
                console.log(message)
                var winners = message['winners']
                for (var i=0;i<winners.length;i++){
                    var winner_div = '<li>'+winners[i]["user"]+':'+winners[i]["right_ans"]+'</li>';
                    winners_list_div.append(winner_div)
                }
            }

        }
</script>
{% endblock %}